class SoundPlayer
{
   var channelsAvailable;
   var channel1;
   var channel2;
   var voiceChannel;
   var hitChannel;
   var externalSoundVolume;
   var start;
   function SoundPlayer()
   {
      this.channelsAvailable = new Array(true,true,true,true);
      this.channel1 = new Sound();
      this.channel2 = new Sound();
      this.voiceChannel = new Sound();
      this.hitChannel = new Sound();
      this.externalSoundVolume = 100;
   }
   function CleanSounds(intIndex)
   {
      this.channelsAvailable[intIndex] = true;
   }
   function PlaySound(linkIdentifier)
   {
      if(_global.soundOn == true)
      {
         var thisRef = this;
         if(this.channelsAvailable[0] == true)
         {
            this.channelsAvailable[0] = false;
            delete this.channel1;
            this.channel1 = new Sound();
            this.channel1.attachSound(linkIdentifier);
            this.channel1.setVolume(100);
            this.channel1.start(0,0);
            this.channel1.onSoundComplete = function()
            {
               thisRef.CleanSounds(0);
            };
         }
         else if(this.channelsAvailable[1] == true)
         {
            this.channelsAvailable[1] = false;
            delete this.channel2;
            this.channel2 = new Sound();
            this.channel2.attachSound(linkIdentifier);
            this.channel2.setVolume(100);
            this.channel2.start(0,0);
            this.channel2.onSoundComplete = function()
            {
               thisRef.CleanSounds(1);
            };
         }
         else
         {
            this.channelsAvailable[0] = false;
            delete this.channel1;
            this.channel1 = new Sound();
            this.channel1.attachSound(linkIdentifier);
            this.channel1.setVolume(100);
            this.channel1.start(0,0);
            this.channel1.onSoundComplete = function()
            {
               thisRef.CleanSounds(0);
            };
         }
      }
   }
   function PlayHitSound(linkIdentifier)
   {
      if(_global.soundOn == true)
      {
         var thisRef = this;
         if(this.channelsAvailable[2] == true)
         {
            this.channelsAvailable[2] = false;
            delete this.hitChannel;
            this.hitChannel = new Sound();
            this.hitChannel.attachSound(linkIdentifier);
            this.hitChannel.setVolume(100);
            this.hitChannel.start(0,0);
            this.hitChannel.onSoundComplete = function()
            {
               thisRef.CleanSounds(2);
            };
         }
      }
   }
   function PlayVoiceSound(linkIdentifier)
   {
      if(_global.soundOn == true)
      {
         var thisRef = this;
         if(this.channelsAvailable[3] == true)
         {
            this.channelsAvailable[3] = false;
            delete this.voiceChannel;
            this.voiceChannel = new Sound();
            this.voiceChannel.attachSound(linkIdentifier);
            this.voiceChannel.setVolume(100);
            this.voiceChannel.start(0,0);
            this.voiceChannel.onSoundComplete = function()
            {
               thisRef.CleanSounds(3);
            };
         }
      }
   }
   function PlayExternalSound(urlPath)
   {
      var thisRef = this;
      if(this.channelsAvailable[0] == true)
      {
         this.channelsAvailable[0] = false;
         delete this.channel1;
         this.channel1 = new Sound();
         this.channel1.loadSound(urlPath,false);
         this.channel1.setVolume(this.externalSoundVolume);
         this.channel1.onLoad = function(loadedOK)
         {
            if(loadedOK)
            {
               this.start();
            }
         };
         this.channel1.onSoundComplete = function()
         {
            thisRef.CleanSounds(0);
         };
      }
      else if(this.channelsAvailable[1] == true)
      {
         this.channelsAvailable[1] = false;
         delete this.channel2;
         this.channel2 = new Sound();
         this.channel2.loadSound(urlPath,false);
         this.channel2.setVolume(this.externalSoundVolume);
         this.channel2.onLoad = function(loadedOK)
         {
            if(loadedOK)
            {
               this.start();
            }
         };
         this.channel2.onSoundComplete = function()
         {
            thisRef.CleanSounds(1);
         };
      }
      else
      {
         this.channelsAvailable[0] = false;
         delete this.channel1;
         this.channel1 = new Sound();
         this.channel1.loadSound(urlPath,false);
         this.channel1.setVolume(this.externalSoundVolume);
         this.channel1.onLoad = function(loadedOK)
         {
            if(loadedOK)
            {
               this.start();
            }
         };
         this.channel1.onSoundComplete = function()
         {
            thisRef.CleanSounds(0);
         };
      }
   }
}
